<?php
/**
	Classe Template v3.0 :
	Auteur : Nasgektw
	Inspir des templates de PHPBB
	
	Historique des fonctionnalits :
		- v1.0 :
			* Utilisation d'un fichier de template par un code PHP :
				notations des variables de Template :
					{NOM_VARIABLE}
				notation des boucles de Template :
					<!-- BEGIN nom_boucle -->
					...
					<!-- END nom_boucle -->
				
				Remarque : les boucles peuvent tre utilises comme des "if" car elles ne sont pas affiches si vides.
			* Fonctions de la classe :
				clear
				parse
				setFile
				setVariables
				setVar
				setVars
				setLoopVar
				setLoopVars
				loadFile
				compile
				
		- v1.1 :
			* Gestion de l'affichage du contenu d'un fichier.
			* Fonction ajoute :
				fileContent
				
		- v2.0 :
			* Gestion des boucles imbriques d'un niveau quelconque :
			* Fonctions ajoutes :
				setReload
				setUncompiled
				setDatas
				getCompiled
				addData
				addDatas
				assignDataTpl
				saveAssignData
				setDatasTpl
		- v3.0 :
			* Possibilit d'affichage du template en temps rel
			* Nouvelle syntaxe pour les templates temps rel :
				Dclaration des blocks d'affichages (au dbut du fichier de template :
					<!-- BEGIN_BLOCKS -->
						<!-- BEGIN nom_block -->
						<!-- END nom_block -->
						...
					<!-- END_BLOCKS -->
			* Fonction ajoute :
				setBlockVar
					
**/
	class Template{

		//dclaration des attributs de la classe
		var $file="";	//Nom du fichier de template
		var $uncompiled="";	//contenu du fichier de template non compil
		var $compiled="";	//contenu de la template prt  l'affichage
		var $variables=array();	//variables de la template
		var $datas=array();
		var $reload=true;
		var $assigns=array();
		var $blocks="";
		
		//Le constructeur initialise le fichier de template
		function Template($f="")
		{
			$this->setFile($f);
		}
		//Dfinit si on doit ou non charger un fichier de template lors de la compilation
		function setReload($bool)
		{
			$this->reload=$bool;
		}
		//Remise  zro des variables de Template
		function clear()
		{
			$this->variables=array();
		}
		//Renseignement du code de template sans passer par un fichier
		function setUncompiled($string)
		{
			$this->uncompiled=$string;
		}
		//Renseignement des donnes des boucles imbriques
		function setDatas($datas)
		{
			$this->datas=$datas;
		}
		/*
			Ajout d'une donne de boucle imbirque :
				$nom : nom du type de donnes
				$id : identifiant de la donne
				$dataname : nom de variable de la donne
				$data : donne
		*/
		function addData($nom, $id, $dataname, $data)
		{
			$this->datas[$nom][$id][$dataname]=$data;
		}
		/*
			Ajout de donnes de boucle imbriques :
				$nom : nom du type de donne
				$id : identifiant de la donne
				$datas : donnes sous forme $dataname => $data
		*/
		function addDatas($nom, $id, $datas)
		{
			foreach($datas as $dataname => $data)
				$this->addData($nom, $id, $dataname, $data);
		}
		/*
			Assigne un type de donne  une variable de template
		*/
		function assignDataTpl($nomtpl, $nomdata)
		{
			$this->variables[$nomtpl]=$this->datas[$nomdata];
		}
		/*
			Assigne un type de donne  un nom de variable de template
		*/
		function saveAssignData($nomtpl, $nomdata)
		{
			$this->assigns[$nomtpl]=$nomdata;
		}
		/*
			Cre toutes les assignations de boucles imbriques demandes
		*/
		function setDatasTpl()
		{
			foreach($this->assigns as $var => $assign)
				$this->assignDataTpl($var, $assign);
		}
		//Rcupre le code de template aprs compilation
		function getCompiled()
		{
			$this->compile();
			return $this->compiled;
		}
		//Affichage
		function parse()
		{
			$this->compile();
			echo $this->compiled;
			flush();
		}
		//Fonction assignant le fichier pass en argument au fichier de template s'il existe
		function setFile($f)
		{
			$this->file=is_file($f)?$f:$this->file;
		}
			
		//Fonction de modification de la variable $variables
		function setVariables($type,$constant,$var)
		{
			$this->variables[$type][][$constant]=$var;
		}
			
			
		//Fonction ajoutant ou modifiant la constante simple $constant
		function setVar($constant,$var)
		{
			$this->setVariables(".",$constant,$var);
		}
			
		//Fonction ajoutant ou modifiant les constantes simples passes en paramtre
		function setVars($infos)
		{
			if(is_array($infos))
			{
				foreach($infos as $constant => $var)
				{
					$this->setVar($constant, $var);
				}
			}
		}
		
		//Fonction ajoutant ou modifiant les constantes bouclantes renseignes dans le tableau $infos
		function setLoopVar($type, $infos)
		{
			if(is_array($infos))
			{
				$n=isset($this->variables[$type])?sizeof($this->variables[$type]):0;
				foreach($infos as $constant => $var)
					$this->variables[$type][$n][$constant]=$var;
			}
		}
		//Fonction affichant en temps rel le block $type renseign avec les variables contenues dans $infos
		function setBlockVars($type, $infos)
		{
			if(is_array($infos))
			{
				if($this->blocks=="")$this->loadFile();
				$block=substr($this->blocks,strpos($this->blocks,"<!-- BEGIN $type -->")+strlen("<!-- BEGIN $type -->"),strpos($this->blocks,"<!-- END $type -->")-strpos($this->blocks,"<!-- BEGIN $type -->")-strlen("<!-- BEGIN $type -->"));
				foreach($infos as $constant => $var)
					$block=(is_array($var) && sizeof($var)>=2 && $var[1]=="file")?ereg_replace("\{".$constant."\}",$this->fileContent($var[0]),$block):ereg_replace("\{".$constant."\}",$var,$block);
				echo $block;
				flush();
			}
		}
					
		//Fonction ajoutant ou modifiant les constantes bouclantes renseignes dans le tableau $tab
		function setLoopVars($type, $tab)
		{
			if(is_array($tab))
			{
				foreach($tab as $infos)
				{
					$this->setLoopVar($type,$infos);
				}
			}
		}
		//Charge le code non-compil  partir de $this->file
		function loadFile()
		{
			if ($this->file=="")
			{
				die("Template->loadfile(): No file specified");
			}
			if(!is_file($this->file))
			{
				die("Template->loadfile(): unvalide file specified");
			}
			if(is_file($this->file))
			{
				$str = implode("", @file($this->file));
				if (empty($str))
				{
					die("Template->loadfile(): File ".$this->file." is empty");
				}
				//Si on a des blocks de codes temps rels, on les isole
				if(ereg("<!-- BEGIN_BLOCKS -->.*<!-- END_BLOCKS -->",$str))
				{
					ereg("(<!-- BEGIN_BLOCKS -->.*<!-- END_BLOCKS -->)(.*)",$str,$regs);
					$this->uncompiled=$regs[2];
					$this->blocks=$regs[1];
				}
				//sinon tout le fichier est un template "normal"
				else
				{
					$this->uncompiled=$str;
				}
				return true;
			}
			else{return false;}
		}
		
		//rcupre le contenu du fichier $file prsent sur le serveur
		function fileContent($file)
		{
			if(is_file($file)){return implode("", @file($file));}
			else{return "";}
		}
		function compile()
		{
			if($this->reload)$this->loadFile();
			$this->setDatasTpl();
			$this->compiled=$this->uncompiled;
			
			/*foreach($this->variables as $type => $tab)
				foreach($tab as $key => $infos)
					foreach($infos as $constant => $var)
						print("$type => $key => $constant => $var<br />");*/
			
			foreach($this->variables as $type => $tab)
			{
				if($type==".")
				{
					foreach($tab as $infos)
					{
						foreach($infos as $constant => $var)
						{
							$this->compiled=(is_array($var) && sizeof($var)>=2 && $var[1]=="file")?ereg_replace("\{".$constant."\}",$this->fileContent($var[0]),$this->compiled):ereg_replace("\{".$constant."\}",$var,$this->compiled);
						}
					}
				}
				else
				{
					if(ereg("<!-- BEGIN $type -->.*<!-- END $type -->",$this->compiled))
					{
						$block=substr($this->compiled,strpos($this->compiled,"<!-- BEGIN $type -->")+strlen("<!-- BEGIN $type -->"),strpos($this->compiled,"<!-- END $type -->")-strpos($this->compiled,"<!-- BEGIN $type -->")-strlen("<!-- BEGIN $type -->"));
						$temp="";
						foreach($tab as $infos)
						{
							$temp2=$block;
							foreach($infos as $constant => $var)
							{
								if(is_array($var) && sizeof($var)==2 && isset($this->datas[$var[0]]) && is_array($var[1]))
								{
									$tpl2=new Template();
									$tpl2->setReload(false);
									$tpl2->setUncompiled($temp2);
									$tpl2->setDatas($this->datas);
									foreach($var[1] as $ids)
										$tpl2->setLoopVar($constant, $this->datas[$var[0]][$ids]);
									$temp2=$tpl2->getCompiled();
								}
								else
								{
									$temp2=(is_array($var) && sizeof($var)>=2 && $var[1]=="file")?ereg_replace("\{".$constant."\}",$this->fileContent($var[0]),$temp2):ereg_replace("\{".$constant."\}",$var,$temp2);
								}
							}
							$temp.=$temp2;
						}
						$this->compiled=ereg_replace("<!-- BEGIN $type -->.*<!-- END $type -->", "$temp" , $this->compiled);
					}
				}
			}
			if($this->reload)
			{
				while(ereg("<!-- BEGIN ([^>]*) -->",$this->compiled,$regs))
					$this->compiled=ereg_replace("<!-- BEGIN ".$regs[1]." -->.*<!-- END ".$regs[1]." -->", "" , $this->compiled);
			}
		}
	}
?>